/*
Copyright 2022, Savanni D'Gerinel <savanni@luminescent-dreams.com>

This file is part of Savanni's AVR library.

Lumeto is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

Lumeto is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with Lumeto. If not, see <https://www.gnu.org/licenses/>.
*/


#ifndef __REG_H__
#define __REG_H__

#include <dio.h>

typedef struct SHIFT_REGISTER {
    dio_t output;
    dio_t shift_clock;
    dio_t latch_clock;
} shift_register_t;


void sr_initialize(shift_register_t *reg);
void sr_send_lsb(shift_register_t *reg, uint8_t byte);
void sr_send_msb(shift_register_t *reg, uint8_t byte);

#endif
