/*
Copyright 2022, Savanni D'Gerinel <savanni@luminescent-dreams.com>

This file is part of Savanni's AVR library.

This AVR library is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

This AVR library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this AVR library. If not, see <https://www.gnu.org/licenses/>.
*/

#include <avr/io.h>
#include <dio.h>

#ifndef __SK9822_H__
#define __SK9822_H__

typedef struct RGB_s {
    uint8_t brightness;
    uint8_t r;
    uint8_t g;
    uint8_t b;
} rgb_t;

typedef struct SK9822 {
    dio_t data_pin;
    dio_t clock_pin;
} sk9822_t;

void sk9822_init(sk9822_t *lights);

void sk9822_send(sk9822_t *lights, rgb_t *pixels, uint8_t count);

#endif
